zero.one=function(x) { 
	if(is.null(dim(x))){
		(x-min(x))/(max(x)-min(x))
	}else{
	apply(x,2, function(x) (x-min(x))/(max(x)-min(x)) ) 
	}
}

IC=function(t,X,parms) {
	nprey=length(X)-2; X=pmax(X,0); 
	x=X[1:nprey]; y=X[nprey+1]; z=X[nprey+2]; 
	Q=sum(pvals*x); R=sum(pivals*x); S = max(0,1 - sum(X));  
	Fy=g*y/(K+Q);  
	Xdot=x*(r*S/(kvals+S)- pvals*Fy - pivals*h*z-1); # prey
	ydot=parms[1]*Fy*Q + eta*z*y - y; 			#predator 1 (specialist)
	zdot=z*(h*R - eta*y - 1);			#predator 2 (generalist)
	dx=c(Xdot,ydot,zdot); dx[X<0]=0; 
	return(list(xdot=dx,c(F1=Fy,x=x,y=y,z=z,S=S)))
}

Dynamics.plot=function(model="IC",y.eps=1,xlab="",ylab="",plot.z=TRUE,runtime=0) { 
########## Solve the model 
	    tvals=seq(0,2000,by=0.25); 
		y0=c(0.5*runif(nprey)/nprey,0.25*runif(2)); 
		out=lsoda(y0,times=tvals,fun=IC,parms=y.eps); # out[,-1]=exp(out[,-1]); 
   	    allprey=out[,2:(nprey+1)]; totprey=apply(allprey,1,sum); yzw=out[,-(1:(nprey+1))]; 


	pj=which(peaks(yzw[,1])==TRUE);
	period1=mean(tail(diff(pj)))*(tvals[2]-tvals[1])
	
	y.out=acf(out[,"y"],lag.max=length(tvals)/2,plot=FALSE);
	period2=min(which(peaks(as.vector(y.out$acf))==TRUE))*(tvals[2]-tvals[1]);
	period=max(period1,period2); 
	plottime=10*(ceiling(0.3*period)); 
	plottime=max(runtime,plottime)

	prey.colors=c("plum4","blue","black","orangered3");
	prey.names=c("z","2","0","y"); 
	
	######### prey-type frequencies 
	preymeans=apply(allprey[tvals>500,],2,mean); ep=(preymeans>1e-6); 

	e=tvals>(max(tvals)-plottime); tmin=min(tvals[e]); tvals=tvals-tmin; 
	predcols=1:ifelse(plot.z,2,1); 
	matplot(tvals[e],cbind(totprey[e],yzw[e,predcols]),type="l",lty=1,lwd=2,col=c("green4","red","purple"),
		xlab=xlab,ylab=ylab,bty="l"); 
		ee=e&(tvals%%2==0); 
	matpoints(tvals[ee],cbind(totprey[ee],yzw[ee,predcols]),type="p",lwd=2,
	pch=c(1,16,17),cex=1.75,col=c("green4","red","purple")); 


 
	
	return(out) 
} 

